﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Trie
{
    class Trie
    {
        private TrieNode root = new TrieNode();

        public TrieNode Insert(string word)
        {
            char[] charArray = word.ToLower().ToCharArray();
            TrieNode node = root;

            foreach (char character in charArray)
            {
                node = Insert(character, node);
            }

            node.IsEnd = true;
            return root;
        }

        private TrieNode Insert(char character, TrieNode node)
        {
            if (node.Contains(character))  
            { 
                return node.GetChild(character);
            }
              else
            {
                int number = Convert.ToByte(character) - TrieNode.ASCIIA;
                TrieNode treeNode = new TrieNode();
                node.nodes[number] = treeNode;
                return treeNode;
            }
        }

        public bool Contains(string word)
        {
            char[] charArray = word.ToLower().ToCharArray();
            TrieNode node = root;
            bool contains = true;

            foreach (char character in charArray)
            {
                node = Contains(character, node);
                if (node == null)
                {
                    contains = false;
                    break;
                }
            }

            if ((node == null) || (!node.IsEnd))
            {
                contains = false;
                
            }
            
            return contains;
        }

        private TrieNode Contains(char character, TrieNode node)
        {
            if(node.Contains(character))
             {
                 return node.GetChild(character);
             }
                
                return null;
            }

        }
}
