﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Trie
{
    class TrieNode
    {
        public TrieNode[] nodes;
        public bool IsEnd { get; set; }
        public int Value { get; set; }
        public const int ASCIIA = 97;
        public const int ENGL = 26;

        public TrieNode()
        {
            nodes = new TrieNode[ENGL];
        }

        public bool Contains(char character)
        {
            int number = Convert.ToByte(character) - ASCIIA;

            if (number > ENGL)
            {
                return false;
            }

            return (nodes[number] != null);
        }

        public TrieNode GetChild(char character)
        {
            int number = Convert.ToByte(character) - ASCIIA;
            return nodes[number];
        }

    }

}
